package com.tutorialesprogramacionya.compose29

import android.os.Bundle
import androidx.activity.ComponentActivity
import androidx.activity.compose.setContent
import androidx.compose.foundation.Canvas
import androidx.compose.foundation.Image
import androidx.compose.foundation.layout.Column
import androidx.compose.foundation.layout.Row
import androidx.compose.foundation.layout.fillMaxSize
import androidx.compose.material.Text
import androidx.compose.runtime.Composable
import androidx.compose.ui.Modifier
import androidx.compose.ui.geometry.Offset
import androidx.compose.ui.geometry.Size
import androidx.compose.ui.graphics.Color
import androidx.compose.ui.graphics.ImageBitmap
import androidx.compose.ui.res.imageResource
import androidx.compose.ui.unit.IntOffset
import androidx.compose.ui.unit.IntSize
import androidx.compose.ui.unit.sp

class MainActivity : ComponentActivity() {
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContent {
            Column() {
                Row {
                    Image(
                        bitmap = ImageBitmap.imageResource(id = R.drawable.peonblanco),
                        contentDescription = ""
                    )
                    Image(
                        bitmap = ImageBitmap.imageResource(id = R.drawable.peonnegro),
                        contentDescription = ""
                    )
                    Text(text = "Peones blancos y negros", fontSize = 30.sp)
                }
                TableroAjedrez()
            }
        }
    }
}

@Composable
fun TableroAjedrez() {
    var peonBlanco = ImageBitmap.imageResource(id = R.drawable.peonblanco)
    var peonNegro = ImageBitmap.imageResource(id = R.drawable.peonnegro)
    Canvas(modifier = Modifier.fillMaxSize(), onDraw = {
        val ancho = size.width
        val alto = size.height
        val anchoCuadrado = if (alto > ancho) ancho / 8f else alto / 8f
        var columna = 0f
        var fila = 0f
        var colorActual = Color.DarkGray
        for (fil in 1..8) {
            for (col in 1..8) {
                drawRect(
                    topLeft = Offset(x = columna, y = fila),
                    size = Size(anchoCuadrado, anchoCuadrado),
                    color = colorActual
                )
                colorActual = if (colorActual == Color.DarkGray) Color.LightGray else Color.DarkGray
                if (fil == 2)
                    drawImage(
                        image = peonBlanco,
                        dstOffset = IntOffset(columna.toInt(), fila.toInt()),
                        dstSize = IntSize(anchoCuadrado.toInt(), anchoCuadrado.toInt())
                    )
                if (fil == 7)
                    drawImage(
                        image = peonNegro,
                        dstOffset = IntOffset(columna.toInt(), fila.toInt()),
                        dstSize = IntSize(anchoCuadrado.toInt(), anchoCuadrado.toInt())
                    )
                columna += anchoCuadrado
            }
            fila += anchoCuadrado
            columna = 0f
            colorActual = if (colorActual == Color.DarkGray) Color.LightGray else Color.DarkGray
        }
    })
}

